﻿@page "/departmentvacation"
@using VacationSchedule.Core.Models.DB;
@inject HttpClient Http

<PageTitle>Структура организации</PageTitle>

<h1>Структура</h1>

@if (depValues == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Подразделение</th>
                <th>ФИО</th>
                <th>Вид отдыха</th>
                <th>Начало</th>
                <th>Окончание</th>
                <th>Примечание</th>
                <th>Утвержден</th>
                <th hidden="@showConfirm">Утвердить</th>
            </tr>
        </thead>
        <tbody>
            @foreach(var v in depValues)
            {
                <tr>
                    <td>@v.DepName</td>
                    <td>@v.FIO</td>
                    <td>@v.VacType</td>
                    <td>@v.VacS.ToString("dd.MM.yyyy")</td>
                    <td>@v.VacE.ToString("dd.MM.yyyy")</td>
                    <td><input type="text" class="form-control" disabled ="@v.IsAccepted" @bind="@v.Comment" /></td>
                    <td align="center"><input type="checkbox" checked=@v.IsAccepted disabled="@((v.IsAccepted && !showConfirm) || showConfirm)" @onclick="@(e => SetAccepted())" style="width:20px; height:20px;" /></td>
                    <td hidden="@showConfirm"><button disabled="@v.IsAccepted" class="btn btn-primary" @onclick="@(e => Confirm(@v))">Save</button></td>
                </tr>
            }
        </tbody>
    </table>

    @if (ShowDialog)
    {
                 <div class="modal fade show d-block" id="cityModal" tabindex="-1" role="dialog">  
                    <div class="modal-dialog">  
                        <div class="modal-content">  
                            <div class="modal-header">  
                                <h5 class="modal-title" id="lbl">Ошибка</h5>
                            </div>  
                            <div class="modal-body">
                                <h5 class="modal-title" id="lbl">@message</h5>
                            </div>  
                             <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" @onclick="hideDialog" data-dismiss="modal">Close</button>
                            </div>
                        </div>  
                    </div>  
                </div>  
    } 
}

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private List<DepValues> depValues = new();
    private User[] users;
    private User user;
    private bool showConfirm = true;
    private bool Assept = false;

    AuthenticationState state;

    private bool ShowDialog = false;
    private string message = "";

    protected override async Task OnInitializedAsync()
    {
        state = await authenticationStateTask;
        user = await Http.GetFromJsonAsync<User>($"api/User/GetByUserName?userName={state.User.Identity.Name}");
        if(user.HeadDepartmentId != null)
        {
            showConfirm = false;
        }
        await RefreshData();
    }

    private async Task RefreshData()
    {
        depValues.Clear();
        users = await Http.GetFromJsonAsync<User[]>($"api/Vacation/GetVacationInDepByUserId?id={user.Id}");
        foreach ( var u in users)
        {
            foreach (var v in u.Vacations)
            {
                depValues.Add(
                new DepValues
                    {
                        Id = v.Id,
                        DepName = u.Department?.DepartmentName,
                        FIO = u.LastName + " " + u.FirstName + " " + u.PatronymicName,
                        VacType = v.VacationType?.Name,
                        VacS = v.VacationStartDate,
                        VacE = v.VacationEndDate,
                        Comment = v.Comment,
                        IsAccepted = v.IsAccepted
                    }
                );
            }
        }
        depValues = depValues.OrderBy(x => x.VacS).ToList();
    }

    private async Task Confirm(DepValues depValue)
    {
        var vacation = new Vacation
            {
                Id = depValue.Id,
                Comment = depValue.Comment,
                IsAccepted = Assept
            };
        var res = await Http.PutAsJsonAsync<Vacation>($"api/Vacation/ConfirmVacation", vacation);
        if (res.StatusCode != System.Net.HttpStatusCode.OK)
        {
            message = await res.Content.ReadAsStringAsync();
            ShowDialog = true;
        }
        Assept = false;
        await RefreshData();
    }

    private async Task SetAccepted()
    {
        Assept = true;
    }

    class DepValues 
    {
        public int Id { get; set; }
        public string DepName { get;set; }
        public string FIO { get; set; }
        public string VacType { get; set; }
        public DateTime VacS { get; set; }
        public DateTime VacE { get; set; }
        public string Comment { get; set; }
        public bool IsAccepted { get; set; }
    }

    void hideDialog()
    {
        ShowDialog = false;
    }
}